USE [ManageSoft]
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_GetInventoryDate' AND xtype = 'IF'
)
        DROP FUNCTION [dbo].[f_GetInventoryDate]
GO
-- ===============================================
-- Author:      P. Arbogast, Raynet GmbH
-- Create date: 14.01.2019
-- Last change: 10.11.2019
-- Copyright:   (c) Raynet GmbH
-- Description:	Get Inventory Dates
-- ===============================================
-- Parameter iType
-- - null   All Inventory Dates of a Device
-- - 1      Only from Machine Inventories
-- - 2      Only from User Inventories
-- ===============================================
-- Connector version:4.0.94.29 
-- ==============================================
CREATE FUNCTION [dbo].[f_GetInventoryDate] (@iType TINYINT)
  RETURNS TABLE
AS
RETURN
  SELECT
      ir.ComputerID,
      ir.UserID,
      CASE
        WHEN ir.HWDate > ir.SWDate AND ir.HWDate > ir.FilesDate THEN ir.HWDate
        WHEN ir.FilesDate > ir.HWDate AND ir.FilesDate > ir.SWDate THEN ir.FilesDate
        WHEN ir.SWDate IS NULL AND ir.FilesDate IS NULL THEN ir.HWDate
        WHEN ir.HWDate IS NULL AND ir.FilesDate IS NULL THEN ir.SWDate
        WHEN ir.HWDate IS NULL AND ir.SWDATE IS NULL THEN ir.FilesDate
        ELSE ir.SWDate
      END AS InventoryDate
    FROM dbo.InventoryReport ir WITH (NOLOCK)
	WHERE @iType IS NULL
      OR (@iType = 1 AND ir.UserID <= 1)
      OR (@iType = 2 AND ir.UserID >= 2)
GO
