USE [ManageSoft]
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_GetLastInventoryDate' AND xtype = 'IF'
)
        DROP FUNCTION [dbo].[f_GetLastInventoryDate]
GO
-- ===============================================
-- Author:      P. Arbogast, Raynet GmbH
-- Create date: 14.01.2019
-- Last change: 
-- Copyright:   (c) Raynet GmbH
-- Description:	Get Last Inventory Dates
-- ===============================================
-- Parameter iType
-- - null   from All Inventory Dates of a Device
-- - 1      Only from Machine Inventories
-- - 2      Only from User Inventories
-- ===============================================
-- Connector version:4.0.94.29 
-- ==============================================
CREATE FUNCTION [dbo].[f_GetLastInventoryDate] (@iType TINYINT)
  RETURNS TABLE
AS
RETURN
  SELECT 
      ir.ComputerID,
      ir.UserID,
      ir.InventoryDate AS LastInventoryDate
    FROM dbo.f_GetInventoryDate(@iType) ir
    WHERE ir.InventoryDate IN (SELECT TOP 1 irTmp.InventoryDate
                                 FROM f_GetInventoryDate(@iType) irTmp
                                 WHERE irTmp.ComputerID = ir.ComputerID
                                 ORDER BY irTmp.InventoryDate DESC)

GO
