USE [ManageSoft]
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_SoftwareValuesByPropertyName' AND xtype = 'IF'
)
        DROP FUNCTION [dbo].[f_SoftwareValuesByPropertyName]
GO
-- ===============================================
-- Author:      P. Arbogast, Raynet GmbH
-- Create date: 15.01.2019
-- Last change: 
-- Copyright:   (c) Raynet GmbH
-- Description:	Get all Values by Property Name
-- ===============================================
-- Parameter sProperty
--   LIKE Serch for Property Name
-- ===============================================
-- Connector version:4.0.94.29 
-- ==============================================
CREATE FUNCTION [dbo].[f_SoftwareValuesByPropertyName] (@sProperty NVARCHAR(256))
      RETURNS TABLE
AS
RETURN
  SELECT sv.SoftwareOccurrenceID, sp.Property, sv.Value
    FROM dbo.SoftwareValue sv WITH (NOLOCK) 
      INNER JOIN dbo.SoftwareProperty sp WITH (NOLOCK) 
        ON (sp.Property IS NULL OR sp.Property LIKE @sProperty)
          AND sv.SoftwarePropertyID = sp.SoftwarePropertyID	
GO

