USE [ManageSoft]
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_GetDeviceChassis' AND xtype = 'IF'
)
        DROP FUNCTION [dbo].[f_GetDeviceChassis]
GO

-- ===============================================
-- Connector version:4.0.94.29 
-- ==============================================


CREATE FUNCTION [dbo].[f_GetDeviceChassis] (@bALL BIT)
  RETURNS TABLE
AS

RETURN
  SELECT
      tmp2.ComputerID,
      tmp2.TypeID,
      CASE tmp2.TypeID
        WHEN 1 THEN 'Other'
        WHEN 2 THEN 'Unknown'
        WHEN 3 THEN 'Desktop'
        WHEN 4 THEN 'Low Profile Desktop'
        WHEN 5 THEN 'Pizza Box'
        WHEN 6 THEN 'Mini Tower'
        WHEN 7 THEN 'Tower'
        WHEN 8 THEN 'Portable'
        WHEN 9 THEN 'Laptop'
        WHEN 10 THEN 'Notebook'
        WHEN 11 THEN 'Hand Held'
        WHEN 12 THEN 'Docking Station'
        WHEN 13 THEN 'All in One'
        WHEN 14 THEN 'Sub Notebook'
        WHEN 15 THEN 'Space-Saving'
        WHEN 16 THEN 'Lunch Box'
        WHEN 17 THEN 'Main System Chassis'
        WHEN 18 THEN 'Expansion Chassis'
        WHEN 19 THEN 'SubChassis'
        WHEN 20 THEN 'Bus Expansion Chassis'
        WHEN 21 THEN 'Peripheral Chassis'
        WHEN 22 THEN 'Storage Chassis'
        WHEN 23 THEN 'Rack Mount Chassis'
        WHEN 24 THEN 'Sealed-Case PC'
        ELSE 'Unknown'
      END AS [Type]
    FROM (SELECT
              tmp.ComputerID,
	          dbo.CIMInteger(MIN(tmp.TypeID)) AS TypeID
            FROM (SELECT
                      c.ComputerID AS ComputerID,
                      c.Value      AS TypeID,
                      IIF(@bALL = 1, ROW_NUMBER() OVER(ORDER BY c.ComputerID ASC), 1)     AS Tmp
                    FROM f_HardwareProperties('CIM_Chassis')  c
                    WHERE Property = 'ChassisTypes') tmp
            GROUP BY tmp.ComputerID, tmp.Tmp) tmp2

GO


