USE [ManageSoft]
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_GetDeviceDiskDrive' AND xtype = 'IF'
)
        DROP FUNCTION [dbo].[f_GetDeviceDiskDrive]
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- ===============================================
-- Author:      P. Arbogast, Raynet GmbH
-- Create date: 24.01.2019
-- Last change: 
-- Copyright:   (c) Raynet GmbH
-- Description:	Get all Disk Drives, without Partition
-- ===============================================
-- Connector version:4.0.94.29 
-- ==============================================

CREATE FUNCTION [dbo].[f_GetDeviceDiskDrive]()
  RETURNS TABLE
AS
RETURN
  SELECT 
      d.ComputerID,
      d.CIMDiskDriveID,
      d.DiskDriveID, 
      d.DiskNumber,
      d.Manufacturer,
      d.Model,
      d.SerialNumber,
      d.Interface,
      d.TotalCapacity
    FROM dbo.f_GetDeviceDiskDriveBase() d
    WHERE d.Class NOT IN ('MGS_DiskDrive')
  UNION SELECT 
      d.ComputerID, 
      d.CIMDiskDriveID,
      d.DiskDriveID, 
      COALESCE(d.DiskNumber, ASCII(SUBSTRING(d.DiskDriveID, 3, 1))) -97 AS DiskNumber,
      d.Manufacturer,
      d.Model,
      d.SerialNumber,
      d.Interface,
      d.TotalCapacity
    FROM dbo.f_GetDeviceDiskDriveBase() d
    WHERE d.Class = 'MGS_DiskDrive'
      AND d.DiskDriveID LIKE '%[a-z]'
GO

