USE [ManageSoft]
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_GetDeviceOSLanguage' AND xtype = 'IF'
)
        DROP FUNCTION [dbo].[f_GetDeviceOSLanguage]
GO
-- ===============================================
-- Author:      P. Arbogast, Raynet GmbH
-- Create date: 15.01.2019
-- Last change: 
-- Copyright:   (c) Raynet GmbH
-- Description:	Get All OS Languages for all Device Elements
-- ===============================================
-- Connector version:4.0.94.29 
-- ==============================================

CREATE FUNCTION [dbo].[f_GetDeviceOSLanguage] ()
  RETURNS TABLE
AS
RETURN
  SELECT
      ComputerID,
      dbo.CIMInteger(osL.Value)   AS LanguageID,
      CASE osL.Value
        WHEN '1' THEN 'Arabic'
        WHEN '4' THEN 'Chinese (Simplified) China'
        WHEN '9' THEN 'English'
        WHEN '1025' THEN 'Arabic  Saudi Arabia'
        WHEN '1026' THEN 'Bulgarian'
        WHEN '1027' THEN 'Catalan'
        WHEN '1028' THEN 'Chinese (Traditional)  Taiwan'
        WHEN '1029' THEN 'Czech'
        WHEN '1030' THEN 'Danish'
        WHEN '1031' THEN 'German  Germany'
        WHEN '1032' THEN 'Greek'
        WHEN '1033' THEN 'English  United States'
        WHEN '1034' THEN 'Spanish  Traditional Sort'
        WHEN '1035' THEN 'Finnish'
        WHEN '1036' THEN 'French  France'
        WHEN '1037' THEN 'Hebrew'
        WHEN '1038' THEN 'Hungarian'
        WHEN '1039' THEN 'Icelandic'
        WHEN '1040' THEN 'Italian  Italy'
        WHEN '1041' THEN 'Japanese'
        WHEN '1042' THEN 'Korean'
        WHEN '1043' THEN 'Dutch  Netherlands'
        WHEN '1044' THEN 'Norwegian  Bokmal'
        WHEN '1045' THEN 'Polish'
        WHEN '1046' THEN 'Portuguese  Brazil'
        WHEN '1047' THEN 'Rhaeto-Romanic'
        WHEN '1048' THEN 'Romanian'
        WHEN '1049' THEN 'Russian'
        WHEN '1050' THEN 'Croatian'
        WHEN '1051' THEN 'Slovak'
        WHEN '1052' THEN 'Albanian'
        WHEN '1053' THEN 'Swedish'
        WHEN '1054' THEN 'Thai'
        WHEN '1055' THEN 'Turkish'
        WHEN '1056' THEN 'Urdu'
        WHEN '1057' THEN 'Indonesian'
        WHEN '1058' THEN 'Ukrainian'
        WHEN '1059' THEN 'Belarusian'
        WHEN '1060' THEN 'Slovenian'
        WHEN '1061' THEN 'Estonian'
        WHEN '1062' THEN 'Latvian'
        WHEN '1063' THEN 'Lithuanian'
        WHEN '1065' THEN 'Persian'
        WHEN '1066' THEN 'Vietnamese'
        WHEN '1069' THEN 'Basque (Basque)'
        WHEN '1070' THEN 'Serbian'
        WHEN '1071' THEN 'Macedonian (Macedonia (FYROM))'
        WHEN '1072' THEN 'Sutu'
        WHEN '1073' THEN 'Tsonga'
        WHEN '1074' THEN 'Tswana'
        WHEN '1076' THEN 'Xhosa'
        WHEN '1077' THEN 'Zulu'
        WHEN '1078' THEN 'Afrikaans'
        WHEN '1080' THEN 'Faeroese'
        WHEN '1081' THEN 'Hindi'
        WHEN '1082' THEN 'Maltese'
        WHEN '1084' THEN 'Scottish Gaelic (United Kingdom)'
        WHEN '1085' THEN 'Yiddish'
        WHEN '1086' THEN 'Malay  Malaysia'
        WHEN '2049' THEN 'Arabic  Iraq'
        WHEN '2052' THEN 'Chinese (Simplified)  PRC'
        WHEN '2055' THEN 'German  Switzerland'
        WHEN '2057' THEN 'English  United Kingdom'
        WHEN '2058' THEN 'Spanish  Mexico'
        WHEN '2060' THEN 'French  Belgium'
        WHEN '2064' THEN 'Italian  Switzerland'
        WHEN '2067' THEN 'Dutch  Belgium'
        WHEN '2068' THEN 'Norwegian  Nynorsk'
        WHEN '2070' THEN 'Portuguese  Portugal'
        WHEN '2072' THEN 'Romanian  Moldova'
        WHEN '2073' THEN 'Russian  Moldova'
        WHEN '2074' THEN 'Serbian  Latin'
        WHEN '2077' THEN 'Swedish  Finland'
        WHEN '3073' THEN 'Arabic  Egypt'
        WHEN '3076' THEN 'Chinese (Traditional)  Hong Kong SAR'
        WHEN '3079' THEN 'German  Austria'
        WHEN '3081' THEN 'English  Australia'
        WHEN '3082' THEN 'Spanish  International Sort'
        WHEN '3084' THEN 'French  Canada'
        WHEN '3098' THEN 'Serbian  Cyrillic'
        WHEN '4097' THEN 'Arabic  Libya'
        WHEN '4100' THEN 'Chinese (Simplified)  Singapore'
        WHEN '4103' THEN 'German  Luxembourg'
        WHEN '4105' THEN 'English  Canada'
        WHEN '4106' THEN 'Spanish  Guatemala'
        WHEN '4108' THEN 'French  Switzerland'
        WHEN '5121' THEN 'Arabic  Algeria'
        WHEN '5127' THEN 'German  Liechtenstein'
        WHEN '5129' THEN 'English  New Zealand'
        WHEN '5130' THEN 'Spanish  Costa Rica'
        WHEN '5132' THEN 'French  Luxembourg'
        WHEN '6145' THEN 'Arabic  Morocco'
        WHEN '6153' THEN 'English  Ireland'
        WHEN '6154' THEN 'Spanish  Panama'
        WHEN '7169' THEN 'Arabic  Tunisia'
        WHEN '7177' THEN 'English  South Africa'
        WHEN '7178' THEN 'Spanish  Dominican Republic'
        WHEN '8193' THEN 'Arabic  Oman'
        WHEN '8201' THEN 'English  Jamaica'
        WHEN '8202' THEN 'Spanish  Venezuela'
        WHEN '9217' THEN 'Arabic  Yemen'
        WHEN '9226' THEN 'Spanish  Colombia'
        WHEN '10241' THEN 'Arabic  Syria'
        WHEN '10249' THEN 'English  Belize'
        WHEN '10250' THEN 'Spanish  Peru'
        WHEN '11265' THEN 'Arabic  Jordan'
        WHEN '11273' THEN 'English  Trinidad'
        WHEN '11274' THEN 'Spanish  Argentina'
        WHEN '12289' THEN 'Arabic  Lebanon'
        WHEN '12298' THEN 'Spanish  Ecuador'
        WHEN '13313' THEN 'Arabic  Kuwait'
        WHEN '13322' THEN 'Spanish  Chile'
        WHEN '14337' THEN 'Arabic  U.A.E.'
        WHEN '14346' THEN 'Spanish  Uruguay'
        WHEN '15361' THEN 'Arabic  Bahrain'
        WHEN '15370' THEN 'Spanish  Paraguay'
        WHEN '16385' THEN 'Arabic  Qatar'
        WHEN '16394' THEN 'Spanish  Bolivia'
        WHEN '17418' THEN 'Spanish  El Salvador'
        WHEN '18442' THEN 'Spanish  Honduras'
        WHEN '19466' THEN 'Spanish  Nicaragua'
        WHEN '20490' THEN 'Spanish  Puerto Rico'
        ELSE 'Unknown'
      END                         AS [Language]
    FROM dbo.f_HardwareProperties('CIM_OperatingSystem') osL
	WHERE osL.Property = 'OSLanguage'
GO


