USE [ManageSoft]
GO
IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_CheckVersion' AND xtype = 'FN'
)
        DROP FUNCTION [dbo].[f_CheckVersion]
GO
-- ==============================================
-- Author:      P. Arbogast, Raynet GmbH
-- Create date: 08.04.2018
-- Copyright:   (c) Raynet GmbH
-- Description: Check Version Range
-- ==============================================
-- Connector version:4.0.94.29 
-- ==============================================

CREATE FUNCTION [dbo].[f_CheckVersion](@Version NVARCHAR(50), @MinVersion NVARCHAR(50), @MaxVersion NVARCHAR(50))
RETURNS BIT
AS
BEGIN
  DECLARE @Major   INT          = CAST(LEFT(@Version, CHARINDEX('.', @Version)-1) AS INT)
  DECLARE @PartVer NVARCHAR(50) = RIGHT(@Version, LEN(@Version) - CHARINDEX('.', @Version))
  DECLARE @Minor   INT          = CAST(LEFT(@PartVer, CHARINDEX('.', REVERSE(@PartVer))-1) AS INT)

  DECLARE @MinCheck BIT = 0
  DECLARE @MaxCheck BIT = 0
  IF @MinVersion IS NULL
    SET @MinCheck = 1
  ELSE
  BEGIN
	IF CHARINDEX('.', @MinVersion) = 0 
    BEGIN
      IF @Major >= CAST(@MinVersion AS INT) 
        SET @MinCheck = 1
    END
	ELSE
	BEGIN
      DECLARE @MinMajor  INT = CAST(LEFT(@MinVersion, CHARINDEX('.', @MinVersion)-1) AS INT)
      SET     @PartVer       = RIGHT(@MinVersion, LEN(@MinVersion) - CHARINDEX('.', @MinVersion))
      DECLARE @MinMinor  INT
      IF CHARINDEX('.', @PartVer) = 0
        SET @MinMinor = CAST(@PartVer AS INT)
      ELSE
        SET @MinMinor = CAST(LEFT(@PartVer, CHARINDEX('.', REVERSE(@PartVer))-1) AS INT)
	  IF @Major > @MinMajor OR (@Major = @MinMajor AND @Minor >= @MinMinor)
        SET @MinCheck = 1
    END
  END
  IF @MaxVersion IS NULL
    SET @MaxCheck = 1
  ELSE
  BEGIN
	IF CHARINDEX('.', @MaxVersion) = 0 
    BEGIN
      IF @Major >= CAST(@MaxVersion AS INT) 
        SET @MaxCheck = 1
    END
	ELSE
	BEGIN
      DECLARE @MaxMajor  INT = CAST(LEFT(@MaxVersion, CHARINDEX('.', @MaxVersion)-1) AS INT)
      SET     @PartVer       = RIGHT(@MaxVersion, LEN(@MaxVersion) - CHARINDEX('.', @MaxVersion))
      DECLARE @MaxMinor  INT
      IF CHARINDEX('.', @PartVer) = 0
        SET @MaxMinor = CAST(@PartVer AS INT)
      ELSE
        SET @MaxMinor = CAST(LEFT(@PartVer, CHARINDEX('.', REVERSE(@PartVer))-1) AS INT)
	  IF @Major < @MaxMajor OR (@Major = @MaxMajor AND @Minor <= @MaxMinor)
        SET @MaxCheck = 1
    END
  END
  IF @MinCheck =1 AND @MaxCheck = 1
    RETURN 1
  
  RETURN 0
END
