USE [ManageSoft]
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_HardwareProperties' AND xtype = 'IF'
)
        DROP FUNCTION [dbo].[f_HardwareProperties]
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO

-- =============================================
-- Author:		P. Arbogast, Raynet GmbH
-- Create date: 13.02.2015
-- Copyright:   (c) Raynet GmbH
-- Description:	Select all Properties from Class Search
-- ==============================================
-- Connector version:4.0.94.29 
-- ==============================================

CREATE FUNCTION [dbo].[f_HardwareProperties] (@ClassSearch NVARCHAR(256))
      RETURNS TABLE
AS

RETURN
	SELECT ho.ComputerID, hc.Class, ho.HardwareObjectID, ho.HardwareName, hp.Property, hv.Value
	  FROM HardwareObject AS ho WITH (NOLOCK)
		INNER JOIN HardwareValue AS hv WITH (NOLOCK)
		  ON ho.HardwareObjectID = hv.HardwareObjectID
		LEFT JOIN HardwareClass AS hc WITH (NOLOCK)
		  ON ho.HardwareClassID = hc.HardwareClassID
		LEFT JOIN dbo.HardwareProperty AS hp WITH (NOLOCK)
		  ON hp.HardwarePropertyID = hv.HardwarePropertyID
		LEFT JOIN dbo.HardwareClass AS sc WITH (NOLOCK)
		  ON hc.SuperClassID = sc.HardwareClassID
	  WHERE hc.Class LIKE @ClassSearch OR sc.Class LIKE @ClassSearch

