USE [ManageSoft]
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_HardwareValuesByPropertyName' AND xtype = 'IF'
)
        DROP FUNCTION [dbo].[f_HardwareValuesByPropertyName]
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- ==============================================
-- Connector version:4.0.94.29 
-- ==============================================

CREATE FUNCTION [dbo].[f_HardwareValuesByPropertyName] (@PropertyName NVARCHAR(255))
      RETURNS TABLE
AS

RETURN
  SELECT HardwareObjectID, Value
    FROM HardwareValue AS hv WITH (NOLOCK)
      INNER JOIN HardwareProperty AS hp WITH (NOLOCK)
        ON hp.HardwarePropertyID = hv.HardwarePropertyID
    WHERE Property = @PropertyName


