USE [ManageSoft]
GO
IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'CIMBoolean' AND xtype = 'FN'
)
        DROP FUNCTION [dbo].[CIMBoolean]
GO
-- ==============================================
-- Author:      P. Arbogast, Raynet GmbH
-- Create date: 28.01.2019
-- Last Change: 
-- Copyright:   (c) Raynet GmbH
-- Description: Get Boolean from String
-- ==============================================
-- Parameter:
--   bValue    Boolean Value as String
-- ==============================================
-- Connector version:4.0.94.29 
-- ==============================================


CREATE FUNCTION [dbo].[CIMBoolean](@sValue NVARCHAR(6))
RETURNS BIT
AS
BEGIN
    RETURN CASE --                    EN     DE     FR     IT/SP Port   NL      Turkey          Pol
      WHEN @sValue IN ('True',  '1', 'yes', 'ja',   'oui', 'si', 'sim',         'evet',         'tak') THEN 1
      WHEN @sValue IN ('False', '0', 'no',  'nein', 'non',       'não', 'nee',  'yok', 'hayır', 'nie') THEN 0
    END
END
GO

