USE [ManageSoft]
GO
IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'CIMUniqueidentifier' AND xtype = 'FN'
)
        DROP FUNCTION [dbo].[CIMUniqueidentifier]
GO
-- ==============================================
-- Author:      P. Arbogast, Raynet GmbH
-- Create date: 31.01.2019
-- Last Change: 
-- Copyright:   (c) Raynet GmbH
-- Description: Get Uniqueidentifier from String
-- ==============================================
-- Parameter:
--   bValue    Uniqueidentifier Value as String
-- ==============================================
-- Connector version:4.0.94.29 
-- ==============================================

CREATE FUNCTION [dbo].[CIMUniqueidentifier](@sValue NVARCHAR(38))
RETURNS UNIQUEIDENTIFIER
AS
BEGIN
  RETURN CASE 
    WHEN @sValue IS NULL                THEN NULL
    WHEN LEN(@sValue) IN (36,38) AND @sValue NOT LIKE '%[^-{}0-9a-fA-F]%'
      THEN CAST(@sValue AS UNIQUEIDENTIFIER)
    WHEN LEN(@sValue) IN (32) AND @sValue NOT LIKE '%[^0-9a-fA-F]%'
      THEN CAST(SUBSTRING(@sValue, 1, 8) + '-' + 
                SUBSTRING(@sValue, 9, 4) + '-' +
                SUBSTRING(@sValue, 13, 4) + '-' +
                SUBSTRING(@sValue, 17, 4) + '-' +
                SUBSTRING(@sValue, 21, 12) AS UNIQUEIDENTIFIER)
  END
END
GO

