USE [ManageSoft]
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_SQLDateTime' AND xtype = 'FN'
)
        DROP FUNCTION [dbo].[f_SQLDateTime]
GO
-- ==============================================
-- Connector version:4.0.94.29 
-- ==============================================

CREATE FUNCTION [dbo].[f_SQLDateTime](@Timestamp NVARCHAR(50))
RETURNS DATETIME
AS
BEGIN
    RETURN CASE
      WHEN @Timestamp IS NULL                 THEN NULL
      WHEN @Timestamp = 'null'                THEN NULL
      WHEN @Timestamp LIKE '1601%' THEN NULL
      WHEN (@Timestamp LIKE '[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]T%') 
	                               THEN CONVERT(DATETIME, SUBSTRING(@Timestamp, 1, 4) + '-' + 
                                                          SUBSTRING(@Timestamp, 5, 2) + '-' +
                                                          SUBSTRING(@Timestamp, 7, 2) + ' ' +
                                                          SUBSTRING(@Timestamp, 10, 2) + ':' +
                                                          SUBSTRING(@Timestamp, 12, 2) + ':' +
                                                          SUBSTRING(@Timestamp, 14, 2), 20) 
      WHEN (@Timestamp LIKE '[0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9]T%Z')
	                               THEN CONVERT(DATETIME, @Timestamp, 127)
      WHEN (@Timestamp LIKE '[0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9]T%') 
	                               THEN CONVERT(DATETIME, @Timestamp, 126)
      WHEN (@Timestamp LIKE '%.%+%'
        AND LEN(@Timestamp) = 25) THEN  CONVERT(DATETIME, SUBSTRING(@Timestamp, 1, 4) + '-' + 
                                                          SUBSTRING(@Timestamp, 5, 2) + '-' +
                                                          SUBSTRING(@Timestamp, 7, 2) + ' ' +
                                                          SUBSTRING(@Timestamp, 9, 2) + ':' +
                                                          SUBSTRING(@Timestamp, 11, 2) + ':' +
                                                          SUBSTRING(@Timestamp, 13, 2), 20)
      WHEN (@Timestamp LIKE '%.%.%[_]%') THEN  CONVERT(DATETIME, SUBSTRING(@Timestamp, 1, 4) + '-' + 
                                                          SUBSTRING(@Timestamp, 6, 2) + '-' +
                                                          SUBSTRING(@Timestamp, 9, 2) + ' ' +
                                                          SUBSTRING(@Timestamp, 12, 2) + ':' +
                                                          SUBSTRING(@Timestamp, 15, 2) + ':' +
                                                          SUBSTRING(@Timestamp, 18, 2), 20) 
      ELSE TRY_CONVERT(DATETIME, @Timestamp, 20)
    END
END
GO
