USE [ManageSoft]
GO
IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_StringSplit' AND xtype IN ('IF', 'TF')
)
        DROP FUNCTION [dbo].[f_StringSplit]
GO
-- ==============================================
-- Author:      P. Arbogast, Raynet GmbH
-- Create date: 20.02.2019
-- Copyright:   (c) Raynet GmbH
-- Description: Split String
-- ==============================================
-- Changes:
-- ==============================================
-- Parameter:
--   sString     String to Split
--   sSeparator  Separtor
-- ==============================================
-- Connector version:4.0.94.29 
-- ==============================================

CREATE FUNCTION [dbo].[f_StringSplit](@sString NVARCHAR(MAX), @sSeparator NVARCHAR(255))
  RETURNS TABLE
AS
RETURN 
  SELECT 
    [Value]
  FROM (SELECT 
            [Value] = LTRIM(RTRIM(SUBSTRING(@sString, [Number],
            CHARINDEX(@sSeparator, @sString + @sSeparator, [Number]) - [Number])))
          FROM (SELECT Number = ROW_NUMBER() OVER (ORDER BY name)
                  FROM sys.all_objects
               ) AS x
          WHERE Number <= LEN(@sString)
            AND SUBSTRING(@sSeparator + @sString, [Number], LEN(@sSeparator)) = @sSeparator
       ) AS y
GO

