USE [ManageSoft]
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_GetDeviceSerialNumber' AND xtype = 'IF'
)
        DROP FUNCTION [dbo].[f_GetDeviceSerialNumber]
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- ===============================================
-- Author:      P. Arbogast, Raynet GmbH
-- Create date: 21.01.2019
-- Copyright:   (c) Raynet GmbH
-- Description:	Get Serialnumber
-- ==============================================
-- Connector version:4.0.94.29 
-- ==============================================

CREATE FUNCTION [dbo].[f_GetDeviceSerialNumber]()
  RETURNS TABLE
AS
RETURN
  SELECT DISTINCT
      c.ComputerID, 
      b.HardwareObjectID         AS CIMBIOSElementID, 
      p.HardwareObjectID         AS CIMProductID, 
      COALESCE(b.Value, p.Value) AS SerialNumber
    FROM dbo.Computer c WITH (NOLOCK)
      LEFT JOIN dbo.f_HardwareProperties('CIM_Product') p
        ON p.Property = 'IdentifyingNumber'
          AND c.ComputerID = p.ComputerID
      LEFT JOIN dbo.f_HardwareProperties('CIM_BIOSElement') b
        ON b.Property = 'SerialNumber'
          AND c.ComputerID = b.ComputerID
    WHERE p.ComputerID > 0 OR b.ComputerID > 0
GO

