USE [ManageSoft]
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_GetDeviceVirtualVMwareUUID' AND xtype = 'IF'
)
        DROP FUNCTION [dbo].[f_GetDeviceVirtualVMwareUUID]
GO
-- ===============================================
-- Author:      P. Arbogast, Raynet GmbH
-- Create date: 22.01.2019
-- Copyright:   (c) Raynet GmbH
-- Description:	Get VMware Guest UUID from Device SerialNumber
-- ==============================================
-- Connector version:4.0.94.29 
-- ==============================================


CREATE FUNCTION [dbo].[f_GetDeviceVirtualVMwareUUID]()
  RETURNS TABLE
AS
RETURN
  SELECT
      s.ComputerID AS GuestID,
      s.CIMBIOSElementID,
      TRY_CAST(SUBSTRING(s.Value, 8, 8) + '-' + 
           SUBSTRING(s.Value, 16, 4) + '-' +
           SUBSTRING(s.Value, 20, 9) + '-' +
           SUBSTRING(s.Value, 29, 12) AS UNIQUEIDENTIFIER) AS UUID
    FROM (SELECT ComputerID, CIMBIOSElementID, REPLACE(SerialNumber, ' ', '') AS Value
            FROM dbo.f_GetDeviceSerialNumber()
            WHERE SerialNumber LIKE 'VMWARE_%' AND LEN(SerialNumber) = 54) s
GO

