USE [ManageSoft]
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_GetVirtualVMwareLinkClusterName' AND xtype = 'IF'
)
        DROP FUNCTION [dbo].[f_GetVirtualVMwareLinkClusterName]
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- ===============================================
-- Author:      P. Arbogast, Raynet GmbH
-- Create date: 22.01.2019
-- Copyright:   (c) Raynet GmbH
-- Description:	Get ESX ClusterName
-- ==============================================
-- Connector version:4.0.94.29 
-- ==============================================

CREATE FUNCTION [dbo].[f_GetVirtualVMwareLinkClusterName] ()
  RETURNS TABLE
AS
RETURN
  SELECT 
      cl.ComputerID                          AS ESXHostID,
      TRY_CAST(vU.Value AS UNIQUEIDENTIFIER) AS vCenterUUID,
      cl.HardwareName                        AS ParentID,
      cl.Value                               AS ClusterName
    FROM dbo.f_HardwareProperties('MGS_Cluster') cl
      INNER JOIN dbo.f_HardwareValuesByPropertyName('TYPE') t
        ON cl.HardwareObjectID = t.HardwareObjectID
          AND t.Value = 'VMotion'
      LEFT JOIN dbo.f_HardwareProperties('VMWARE_InfrastructureSDK') vU
        ON vU.Property = 'Server'
          AND cl.ComputerID = vU.ComputerID
    WHERE cl.Property = 'ElementName' 
GO

