USE [ManageSoft]
GO
IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_GetVirtualHyperVHostInfo' AND xtype = 'IF'
)
        DROP FUNCTION [dbo].[f_GetVirtualHyperVHostInfo]
GO
-- ===============================================
-- Author:      P. Arbogast, Raynet GmbH
-- Create date: 30.01.2019
-- Copyright:   (c) Raynet GmbH
-- Description:	Get all Information from all HyperV Hosts
--              only ndtrack by Guest Inventories
-- ==============================================
-- Connector version:4.0.94.29 
-- ==============================================
-- Used Functions:
-- - for All
--   - f_HardwareProperties(<ClassName>)
--   - f_HardwareValuesByPropertyName(<PropertyName>)


CREATE FUNCTION [dbo].[f_GetVirtualHyperVHostInfo]()
  RETURNS TABLE
AS

RETURN
-- HyperV from ndtrack PlugIN
  SELECT
      hE.ComputerID                          AS HyperVGuestID,
	  TRY_CAST(hS.Value AS UNIQUEIDENTIFIER) AS SystemGuid,
      hDns.Value                             AS FQDN
  FROM (SELECT ComputerID, HardwareObjectId, Value FROM dbo.f_HardwareProperties('HyperV_Host') WHERE Property = 'ElementName') hE
    LEFT JOIN dbo.f_HardwareValuesByPropertyName('SystemGuid') hS
      ON hE.HardwareObjectID = hS.HardwareObjectID
    LEFT JOIN dbo.f_HardwareValuesByPropertyName('DNSNameHost') hDns
      ON hE.HardwareObjectID = hDns.HardwareObjectID
GO



