USE [ManageSoft]
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'f_GetVirtualHyperVLinkClusterName' AND xtype = 'IF'
)
        DROP FUNCTION [dbo].[f_GetVirtualHyperVLinkClusterName]
GO
-- ===============================================
-- Author:      P. Arbogast, Raynet GmbH
-- Create date: 28.01.2019
-- Copyright:   (c) Raynet GmbH
-- Description:	Get all Cluster Information from HyperV
--              ndtrack and RWI
-- ===============================================
-- Based on f_Virtual_HyperV_Cluster
-- ==============================================
-- Connector version:4.0.94.29 
-- ==============================================
-- Used Functions:
-- - for All
--   - f_HardwareProperties(<ClassName>)
--   - f_HardwareValuesByPropertyName(<PropertyName>)


CREATE FUNCTION [dbo].[f_GetVirtualHyperVLinkClusterName]()
  RETURNS TABLE
AS
RETURN
-- HyperV from RWI Data
  SELECT
      hC.ComputerID              AS HyperVHostID, 
      hC.Value                   AS ClusterName, 
      CAST(NULL AS BIT)          AS IsFailover
    FROM dbo.f_HardwareProperties('MSCluster_Cluster') hC
     INNER JOIN (SELECT DISTINCT ComputerID FROM dbo.f_HardwareProperties('Msvm_ComputerSystem')) hG
       ON hC.ComputerID = hG.ComputerID
    WHERE Property = 'Name'
-- HyperV from ndtrack PlugIN
  UNION SELECT
      hC.ComputerID              AS HyperVHostID, 
	  hC.Value                   AS ClusterName,
      dbo.CIMBoolean(hF.Value)   AS IsFailover
  FROM (SELECT ComputerID, HardwareObjectId, Value FROM dbo.f_HardwareProperties('HyperV_ClusterName') WHERE Property = 'ClusterName') hC
    LEFT JOIN dbo.f_HardwareValuesByPropertyName('IsFailover') hF
      ON hC.HardwareObjectID = hF.HardwareObjectID
    INNER JOIN (SELECT DISTINCT ComputerID FROM dbo.f_HardwareProperties('HyperV_Guest')) hG
      ON hC.ComputerID = hG.ComputerID
GO
