@echo off
rem -----------------------------------------------------------
rem Database Server RMS / RayVentory
rem -----------------------------------------------------------
set SQLServer=localhost
set SQLServerInstance=SQLExpress
set SQLDatabase=ManageSoft
set clean=
set switch=
set startPath=%~dp0

rem -----------------------------------------------------------
rem Read Commandline
rem -----------------------------------------------------------
setlocal enableDelayedExpansion
set argCount=0
for %%x in (%*) do set /A argCount+=1

set /a counter=0
:next
  set /a counter=!counter!+1
  set /a nextCount=!counter!+1

rem Help
  IF /I "%%!counter!" EQU "/?" (
    goto :Help
  )

rem SQL Server
  IF /I "%%!counter!" EQU "/ss" (
    set switch=y
    set /a counter=!counter!+1
    set SQLServer=%%!counter!
  )

rem SQL Server Instance
  IF /I "%%!counter!" EQU "/si" (
    set switch=y
    set /a counter=!counter!+1
    set SQLServerInstance=%%!counter!
  )

rem SQL Database
  IF /I "%%!counter!" EQU "/sd" (
    set switch=y
    set /a counter=!counter!+1
    set SQLDatabase=%%!counter!
  )

  IF %argCount% GTR %counter% goto :next  
endlocal

rem -----------------------------------------------------------
rem Ask Questions
rem -----------------------------------------------------------
IF /I "%switch%" equ "y" goto :endQuestions
  echo.
  echo SQL Server Settings for ManageSoft Database
  echo -------------------------------------------
  echo.
  set /P SQLServerNew=SQL Server       (%SQLServer%):
  IF /I "%SQLServerNew%" NEQ "" set SQLServer=%SQLServerNew%

  set /P SQLServerInstanceNew=Instance         (%SQLServerInstance%):
  IF /I "%SQLServerInstanceNew%" NEQ "" set SQLServerInstance=%SQLServerInstanceNew%

  set /P SQLDatabaseNew=Database Name    (%SQLDatabase%):
  IF /I "%SQLDatabaseNew%" NEQ "" set SQLDatabase=%SQLDatabaseNew%
:endQuestions

rem -----------------------------------------------------------
rem Other Variables
rem -----------------------------------------------------------

if not "%SQLServerInstance%"=="" set SQLServer=%SQLServer%\%SQLServerInstance%

set DOMAINNAME=%COMPUTERNAME%
if not "%USERDOMAIN%"=="" set DOMAINNAME=%USERDOMAIN%


rem -----------------------------------------------------------
rem Start SQL Import
rem -----------------------------------------------------------

rem System

rem Inventory Hardware Overview
pushd "%startPath%SQL\Oracle"

"%startPath%mgsDatabaseUpdate" -i Oracle_Install.xml -s %SQLServer% -d %SQLDatabase% -nsu
popd

pushd "%startPath%SQL\Aspera"

"%startPath%mgsDatabaseUpdate" -i Aspera_Install.xml -s %SQLServer% -d %SQLDatabase% -nsu
popd

popd

rem -----------------------------------------------------------
rem End SQL Import
rem -----------------------------------------------------------
goto :endScript
:endScript
exit /b 0

:help
rem -----------------------------------------------------------
rem Help
rem -----------------------------------------------------------
echo.
rem  12345678901234567890123456789012345678901234567890123456789012345678901234567890
echo.  installReport.cmd [/ss {SQL Server}]       [/si {SQL Server Instance}] 
echo.                    [/sd {SQL Database}] 
echo.
echo. ManageSoft Database
echo.   /ss      SQL Server           (default localhost)
echo.   /si      SQL Server Instance  (default no instance)
echo.   /sd      SQL Database         (default ManageSoft)
echo.
echo.
echo. If no Database Parameter is set, all Database will be ask.
echo. For silent Installation set minimum "/ss localhost /clean"
echo.
